package mirage-crypto-rng

  1. Overview
  2. Docs
A cryptographically secure PRNG

Install

Dune Dependency

Authors

Maintainers

Sources

mirage-crypto-v0.6.2.tbz
sha256=e2284dc0f8d37110f4713b87145a26a2bbce3e43f14be51e88de18db5922b823
sha512=2c9808261aec8498921e4dce2d66214e10dfe65e2c3729c081731d6c44abc0e990233e5398c9c2d31a97d1a40bdd38920c54817f572d3b592f4257ce85b331da

Description

Mirage-crypto-rng provides a random number generator interface, and implementations: Fortuna, HMAC-DRBG, getrandom/getentropy based (in the unix sublibrary)

Published: 19 Mar 2020

README

mirage-crypto - Cryptographic primitives for MirageOS

v0.6.2

mirage-crypto is a small cryptographic library that puts emphasis on the applicative style and ease of use. It includes basic ciphers (AES, 3DES, RC4), hashes (MD5, SHA1, SHA2 family), AEAD primitives (AES-GCM, AES-CCM), public-key primitives (RSA, DSA, DH) and a strong RNG (Fortuna).

RSA timing attacks are countered by blinding. AES timing attacks are avoided by delegating to AES-NI.

Mirage-crypto is a fork of the ocaml-nocrypto written by David Kaloper. It was forked with the permission of the original author in order to facilitate changes (e.g. build system) required by Mirage that the upstream didn't have time to keep up with.

Mirage-crypto-entropy embeds the former mirage-entropy opam package, which implements various entropy sources for MirageOS unikernels:

API documentation online

Build

dune build
dune runtest

FAQ

RNG seeding

If RNG fails with Fatal error: exception Uncommon.Boot.Unseeded_generator, you need to [seed][doc-entropy] it.

Unix:

let () = Mirage_crypto_rng_unix.initialize ()
Illegal instructions
Program terminated with signal SIGILL, Illegal instruction.
#0  _mm_aeskeygenassist_si128 (__C=<optimized out>, __X=...)

Mirage_crypto has CPU acceleration support (SSE2+AES-NI), but no run-time autodetection yet. You compiled the library with acceleration, but you are using it on a machine that does not support it.

The environment variable MIRAGE_CRYPTO_ACCELERATE can be used to override detection:

  • MIRAGE_CRYPTO_ACCELERATE=false dune build force-disables non-portable code.

  • MIRAGE_CRYPTO_ACCELERATE=true dune build force-enables non-portable code.

  • Otherwise, it matches the capabilities of the build machine.

Dependencies (5)

  1. mirage-crypto = version
  2. cstruct >= "3.2.0"
  3. dune-configurator
  4. dune >= "1.7"
  5. ocaml >= "4.07.0"

Dev Dependencies (3)

  1. ounit with-test
  2. randomconv with-test & >= "0.1.3"
  3. ounit with-test

Used by (39)

  1. awa < "0.1.2"
  2. awa-lwt
  3. builder-web
  4. caldav
  5. capnp-rpc-net >= "0.9.0"
  6. caqti-eio >= "2.1.1"
  7. certify >= "0.3.3"
  8. conex-mirage-crypto
  9. current_web >= "0.3" & < "0.6.4"
  10. dkim >= "0.2.0" & < "0.5.0"
  11. dkim-mirage >= "0.2.0" & < "0.5.0"
  12. dns-cli >= "4.4.0" & < "4.6.0"
  13. dns-client >= "4.5.0" & < "4.6.1"
  14. dns-server >= "4.4.0" & < "7.0.0"
  15. dream >= "1.0.0~alpha5"
  16. git = "2.1.3"
  17. git-mirage = "2.1.3"
  18. git-unix = "2.1.3"
  19. http-mirage-client >= "0.0.3"
  20. hyper >= "1.0.0~alpha2"
  21. jose >= "0.8.2"
  22. letsencrypt >= "0.2.1" & < "0.5.0"
  23. letsencrypt-app < "0.5.0"
  24. miou
  25. mirage-block-ccm = "1.1.0"
  26. mirage-crypto-entropy >= "0.6.2"
  27. mirage-crypto-pk = "0.6.2"
  28. mrmime >= "0.5.0"
  29. otr >= "0.3.7" & < "0.3.10"
  30. paf < "0.5.0"
  31. paf-cohttp < "0.5.0"
  32. rfc6287 >= "1.0.4"
  33. session >= "0.5.0"
  34. ssh-agent >= "0.3.0" & < "0.4.1"
  35. tls >= "0.11.0" & < "0.12.2"
  36. twostep
  37. u2f
  38. webauthn
  39. x509 >= "0.10.0" & < "0.16.4"

Conflicts

None